<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Moblog Plugin                                                             |
// +---------------------------------------------------------------------------+
// | plugins/moblog/autoinstall.php                                            |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009 by the following authors:                              |
// |                                                                           |
// | Authors: Yoshinori Tahara - taharaxp AT gmail DOT com                     |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

/**
* @package Moblog
*/

/**
* Plugin autoinstall function
*
* @param    string  $pi_name    Plugin name
* @return   array               Plugin information
*
*/
function plugin_autoinstall_moblog($pi_name)
{
    $pi_name         = 'moblog';
    $pi_display_name = 'Moblog';
    $pi_admin        = $pi_display_name . ' Admin';

    $info = array(
        'pi_name'         => $pi_name,
        'pi_display_name' => $pi_display_name,
        'pi_version'      => '1.0.0',
        'pi_gl_version'   => '1.6.0',
        'pi_homepage'     => 'http://www.trybase.com/~dengen/log/'
    );

    $groups = array(
        $pi_admin => 'Users in this group can administer the '
                     . $pi_display_name . ' plugin'
    );

    $features = array(
        $pi_name . '.admin' => 'Full access to ' . $pi_display_name . ' plugin',
    );

    $mappings = array(
        $pi_name . '.admin' => array($pi_admin),
    );

    $tables = array(
        'moblog'
    );

    $inst_parms = array(
        'info'      => $info,
        'groups'    => $groups,
        'features'  => $features,
        'mappings'  => $mappings,
        'tables'    => $tables
    );

    return $inst_parms;
}

function plugin_load_configuration_moblog($pi_name)
{
    global $_CONF;

    $base_path = $_CONF['path'] . 'plugins/' . $pi_name . '/';

    require_once $_CONF['path_system'] . 'classes/config.class.php';
    require_once $base_path . 'install_defaults.php';

    return plugin_initconfig_moblog();
}

function plugin_postinstall_moblog($pi_name)
{
    global $_CONF, $_TABLES;

    $c = DB_count($_TABLES['topics'], 'tid', 'General');
    if ($c) {
        $tid = 'General';
    } else {
        $result = DB_query("SELECT tid FROM {$_TABLES['topics']}");
        $A = DB_fetchArray($result);
        $tid = $A['tid'];
    }

    $result = DB_query("SELECT uid FROM {$_TABLES['users']}");
    while ($A = DB_fetchArray($result)) {
        $sql = "INSERT INTO {$_TABLES['moblog']} "
             . "(uid, email, default_tid, default_subject, enable_thmb, thmb_width, thmb_height, image_width, image_height) "
             . "VALUES ('{$A['uid']}', '', '$tid', 'Moblog', '1', '240', '240', '640', '640')";
        DB_query($sql);
    }

    return true;
}

/**
* Check if the plugin is compatible with this Geeklog version
*
* @param    string  $pi_name    Plugin name
* @return   boolean             true: plugin compatible; false: not compatible
*
*/
function plugin_compatible_with_this_version_moblog($pi_name)
{
    global $_CONF, $_DB_dbms;

    // check if we support the DBMS the site is running on
    $dbFile = $_CONF['path'] . 'plugins/' . $pi_name . '/sql/'
            . $_DB_dbms . '_install.php';
    if (! file_exists($dbFile)) {
        return false;
    }

    if (!function_exists('SEC_createToken')) {
        return false;
    }

    return true;
}

?>
