<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Moblog Plugin                                                             |
// +---------------------------------------------------------------------------+
// | plugins/moblog/language/english.php                                       |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009 by the following authors:                              |
// |                                                                           |
// | Authors: Yoshinori Tahara (dengen) - taharaxp AT gmail DOT com            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

/**
* @package Moblog
*/

/**
* Import Geeklog plugin messages for reuse
*
* @global array $LANG32, $LANG_ADMIN
*/
global $LANG32, $LANG_ADMIN;

$LANG_MOBLOG_1 = array(
    'plugin_name'     => 'Moblog',
    'user_setting'    => 'Moblog User Setting',
    'user_conf'       => 'Moblog Setting',
    'run_moblog'      => 'Moblog Execution',
    'check_moblog'    => 'Moblog Cheker',
    'uid'             => 'User ID',
    'username'        => 'Username',
    'email'           => 'Mobile Email Address',
    'default_tid'     => 'Default Topic ID',
    'default_topic'   => 'Default Topic',
    'default_subject' => 'Default Title',
    'enable_thmb'     => 'Use Thumbnail',
    'thmb_width'      => 'Max Thumbnail Width (px)',
    'thmb_height'     => 'Max Thumbnail Height (px)',
    'image_width'     => 'Max Image Width (px)',
    'image_height'    => 'Max Image Height (px)',
    'password'        => 'Password',
    'password_info'   => 'Don\'t check password when being as empty.',
    'save'            => $LANG_ADMIN['save'],
    'cancel'          => $LANG_ADMIN['cancel'],
    'yes'             => 'True',
    'no'              => 'False',
    'error_field'     => 'There is an item un-entered or wrong.',
    'process_start'   => '----- Moblog Process Start',
    'process_break'   => '----- Moblog Process Break',
    'process_end'     => '----- Moblog Process End',
    'msg_undefined_email'  => 'Mobile Email address isn\'t set.',
    'msg_pop_open_success' => 'POP Server: Connection Success',
    'msg_pop_open_failure' => 'POP Server: Connection Failure',
    'msg_pop_id_success'   => 'POP Server: User ID Sending Success',
    'msg_pop_id_failure'   => 'POP Server: User ID Sending Failure',
    'msg_pop_pass_success' => 'POP Server: Password Sending Success',
    'msg_pop_pass_failure' => 'POP Server: Password Sending Failure',
    'msg_pop_email_none'   => 'POP Server: There is not Email.',
    'msg_pop_email_num'    => 'POP Server: %d Pieces of Email',
    'msg_process_number'   => 'The %dst Processing',
    'msg_disallow_guest'   => 'The posting of the anonymous user isn\'t permitted.',
    'msg_deleted_email'    => 'The email was deleted.',
    'msg_skip_others'      => 'Skipped in the email from the other members.',
    'msg_skip_by_limits'   => 'Skipped by the limitation of the capacity of the imagefile or on the kind of it.',
    'msg_mismatch_pass'    => 'Invalid password for Moblog.',
    'msg_post_success'     => 'Article was posted correctly.',
    'msg_permission_denied' => 'No permission. The article was not posted.',
    'msg_post_error'       => 'Error, Post failed.',
    'msg_no_access_topic'  => 'You don\'t have an access right to the topic (ID:%d). Post failed.',
    'msg_submission_success' => 'Article was added to the submission queue correctly.',
    'msg_thumb_dir_none'   => 'There is no directory to save images.',
    'msg_tmp_dir_none'     => 'There is no directory to save thumbnails.',
);

// Messages for COM_showMessage the submission form

$PLG_moblog_MESSAGE2 = 'The setting of Moblog was saved.';
$PLG_moblog_MESSAGE3 = 'The setting of Moblog was canceled.';
$PLG_moblog_MESSAGE4 = 'Failed to connect to the mail server. Please confirm "Configuration : moblog : POP3 Server Settings".';

// Messages for the plugin upgrade
$PLG_moblog_MESSAGE3002 = $LANG32[9]; // "requires a newer version of Geeklog"

// Localization of the Admin Configuration UI
$LANG_configsections['moblog'] = array(
    'label' => 'Moblog',
    'title' => 'Moblog̐ݒ'
);

$LANG_confignames['moblog'] = array(
    'default_tid'         => 'Default Topic ID',
    'tid_separater'       => 'Option Separater in Title',
    'enable_cronjob'      => 'Cronjob Enable',
    'default_subject'     => 'Default Title',
    'image_width'         => 'Max Image Width (px)',
    'image_height'        => 'Max Image Height (px)',
    'image_maxbyte'       => 'Max Image Capacity (byte)',
    'enable_thmb'         => 'Use Thumbnail',
    'thmb_width'          => 'Max Thumbnail Width (px)',
    'thmb_height'         => 'Max Thumbnail Height (px)',
    'thumb_url'           => 'Thumbnails URL',
    'thumb_dir'           => 'Thumbnails Path',
    'tmp_url'             => 'Images URL',
    'tmp_dir'             => 'Images Path',
    'mailserver_host'     => 'Host Name',
    'mailserver_user'     => 'User ID',
    'mailserver_pass'     => 'Password',
    'mailserver_port'     => 'Port Number',
);

$LANG_configsubgroups['moblog'] = array(
    'sg_main' => 'Main Settings'
);

$LANG_fs['moblog'] = array(
    'fs_main'       => 'Moblog Main Settings',
    'fs_images'     => 'Images Settings',
    'fs_mailserver' => 'POP3 Server Settings',
);

// Note: entries 0, 1, and 12 are the same as in $LANG_configselects['Core']
$LANG_configselects['moblog'] = array(
    0 => array('True' => 1, 'False' => 0),
    1 => array('True' => TRUE, 'False' => FALSE),
);

?>