<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Moblog Plugin                                                             |
// +---------------------------------------------------------------------------+
// | plugins/moblog/language/japanese_utf-8.php                                |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009 by the following authors:                              |
// |                                                                           |
// | Authors: Yoshinori Tahara (dengen) - taharaxp AT gmail DOT com            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

/**
* @package Moblog
*/

/**
* Import Geeklog plugin messages for reuse
*
* @global array $LANG32, $LANG_ADMIN
*/
global $LANG32, $LANG_ADMIN;

$LANG_MOBLOG_1 = array(
    'plugin_name'     => 'モブログ',
    'user_setting'    => 'モブログのユーザ設定',
    'user_conf'       => 'モブログ設定',
    'run_moblog'      => 'モブログの実行',
    'check_moblog'    => 'モブログの動作確認',
    'uid'             => 'ユーザID',
    'username'        => 'ユーザ名',
    'email'           => '携帯端末のメールアドレス',
    'default_tid'     => '話題IDの既定値',
    'default_topic'   => '話題の既定値',
    'default_subject' => 'タイトルの既定値',
    'enable_thmb'     => 'サムネイルを使用する',
    'thmb_width'      => 'サムネイルの最大幅 (px)',
    'thmb_height'     => 'サムネイルの最大高 (px)',
    'image_width'     => '画像の最大幅 (px)',
    'image_height'    => '画像の最大高 (px)',
    'password'        => 'パスワード',
    'password_info'   => '空欄にするとパスワードをチェックしません。',
    'save'            => $LANG_ADMIN['save'],
    'cancel'          => $LANG_ADMIN['cancel'],
    'yes'             => 'はい',
    'no'              => 'いいえ',
    'error_field'     => '未入力または入力が不適切な項目があります',
    'process_start'   => '----- Moblog Process Start',
    'process_break'   => '----- Moblog Process Break',
    'process_end'     => '----- Moblog Process End',
    'msg_undefined_email'  => '携帯端末のメールアドレスが未設定です。',
    'msg_pop_open_success' => 'メールサーバー: 接続成功',
    'msg_pop_open_failure' => 'メールサーバー: 接続失敗',
    'msg_pop_id_success'   => 'メールサーバー: ユーザーID 送信成功',
    'msg_pop_id_failure'   => 'メールサーバー: ユーザーID 送信失敗',
    'msg_pop_pass_success' => 'メールサーバー: パスワード 送信成功',
    'msg_pop_pass_failure' => 'メールサーバー: パスワード 送信失敗',
    'msg_pop_email_none'   => 'メールサーバー: メールはありません。',
    'msg_pop_email_num'    => 'メールサーバー: %d件のメール',
    'msg_process_number'   => '%d件目の処理',
    'msg_disallow_guest'   => 'ゲストユーザの投稿は許可されていません。',
    'msg_deleted_email'    => 'メールは削除されました。',
    'msg_skip_others'      => 'ほかの登録ユーザからのメールをスキップしました。',
    'msg_skip_by_limits'   => '画像ファイルの容量または種類の制限によりスキップしました。',
    'msg_mismatch_pass'    => 'モブログのパスワードが正しくありません。',
    'msg_post_success'     => '正常に投稿されました。',
    'msg_permission_denied' => '権限がないため投稿されませんでした。',
    'msg_post_error'       => 'エラーが発生し、投稿は失敗しました。',
    'msg_no_access_topic'  => '話題(ID:%d)へのアクセス権がなく、投稿は失敗しました。',
    'msg_submission_success' => '正常に承認待ちリストに追加されました。',
    'msg_thumb_dir_none'   => '画像の保存先のディレクトリがありません。',
    'msg_tmp_dir_none'     => 'サムネイルの保存先のディレクトリがありません。',
);

// Messages for COM_showMessage the submission form

$PLG_moblog_MESSAGE2 = 'モブログの設定は保存されました。';
$PLG_moblog_MESSAGE3 = 'モブログの設定はキャンセルされました。';
$PLG_moblog_MESSAGE4 = 'メールサーバーとの接続に失敗しました。「コンフィギュレーション : モブログ : POP3メールサーバーの設定」を確認してください。';

// Messages for the plugin upgrade
$PLG_moblog_MESSAGE3002 = $LANG32[9]; // "requires a newer version of Geeklog"

// Localization of the Admin Configuration UI
$LANG_configsections['moblog'] = array(
    'label' => 'モブログ',
    'title' => 'モブログの設定'
);

$LANG_confignames['moblog'] = array(
    'default_tid'         => '話題IDの既定値',
    'tid_separater'       => 'タイトルのオプション指定用セパレータ',
    'enable_cronjob'      => 'Cronjobを有効にする',
    'default_subject'     => 'タイトルの既定値',
    'image_width'         => '画像の最大幅 (px)',
    'image_height'        => '画像の最大高 (px)',
    'image_maxbyte'       => '画像の最大容量 (byte)',
    'enable_thmb'         => 'サムネイルを使用する',
    'thmb_width'          => 'サムネイルの最大幅 (px)',
    'thmb_height'         => 'サムネイルの最大高 (px)',
    'thumb_url'           => 'サムネイルの保存先URL',
    'thumb_dir'           => 'サムネイルの保存先パス',
    'tmp_url'             => '画像の保存先URL',
    'tmp_dir'             => '画像の保存先パス',
    'mailserver_host'     => 'ホスト名',
    'mailserver_user'     => 'ユーザーID',
    'mailserver_pass'     => 'パスワード',
    'mailserver_port'     => 'ポート番号',
);

$LANG_configsubgroups['moblog'] = array(
    'sg_main' => 'メイン'
);

$LANG_fs['moblog'] = array(
    'fs_main'       => 'モブログのメイン設定',
    'fs_images'     => '画像の設定',
    'fs_mailserver' => 'POP3メールサーバーの設定',
);

// Note: entries 0, 1, and 12 are the same as in $LANG_configselects['Core']
$LANG_configselects['moblog'] = array(
    0 => array('はい' => 1, 'いいえ' => 0),
    1 => array('はい' => TRUE, 'いいえ' => FALSE),
);

?>