<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Moblog Plugin                                                             |
// +---------------------------------------------------------------------------+
// | plugins/moblog/moblog.php                                                 |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009 by the following authors:                              |
// |                                                                           |
// | Authors: Yoshinori Tahara (dengen) - taharaxp AT gmail DOT com            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

// +---------------------------------------------------------------------------+
// | Moblog Plugin は以下のコードをベースに作成しています。                    |
// +---------------------------------------------------------------------------+
// | メールで記事投稿   custom_photomail.php   Ver2.20070130                   |
// +---------------------------------------------------------------------------+
// | gl_photomail.php      ver0.13                                             |
// | Geeklogにて、携帯からPhotoGalleryに追加するパッチ                         |
// | Copyright (C) 2005 by the following authors:                              |
// | Authors: Y.Nakata        - http://ibd.vonakata.com/                       |
// +---------------------------------------------------------------------------+
// | 参考サイト http://xx.nakahara21.net/                                      |
// | 参考記事   http://xx.nakahara21.net/item_133.html                         |
// |    上のNP_HeelloWorld.phpを一部流用しています。                           |
// +---------------------------------------------------------------------------+
// | をベースに改造しています。                                                |
// | 2005/03/29 modify by TSUCHITANI,Kazuko tsuchi AT geeklog DOT jp           |
// +---------------------------------------------------------------------------+

if (strpos(strtolower($_SERVER['PHP_SELF']), 'moblog.php') !== false) {
    die ('This file can not be used on its own.');
}

require_once $_CONF['path_system'] . 'lib-story.php';
require_once $_CONF['path'] . 'plugins/moblog/moblog_story.php';
require_once $_CONF['path'] . 'plugins/moblog/include/qdmail_receiver.php';


//log 出力モード設定　0:作成しない 1:ファイルに出力 2:画面にも出力
$logmode = 1;
if (!empty($_USER['username'])) {
    $logmode = 2;
}

// 対応MIMEタイプ（正規表現）Content-Type: image/jpegの後ろの部分
$_MOBLOG_CONF['subtype'] = "gif|jpe?g|png|bmp";

// 保存しないファイル(正規表現)
$_MOBLOG_CONF['viri'] = '.+\.exe$|.+\.zip$|.+\.pif$|.+\.scr$';

// サムネイルを作る対象画像
$_MOBLOG_CONF['thumb_ext'] = '.+\.jpe?g$|.+\.png$';

// 内部エンコーディング
$_MOBLOG_CONF['charset'] = COM_getCharset();

// タイトルのオプション指定用セパレータ
$_MOBLOG_CONF['tid_separater'] = '@';

// 簡易なログインフォーム
function MOBLOG_loginform()
{
    global $_CONF, $LANG01, $LANG04, $_MOBLOG_CONF;
    $retval = '';
    $user_templates = new Template ($_MOBLOG_CONF['path_layout']);
    $user_templates->set_file('login', 'loginform.thtml');
    $user_templates->set_var( 'xhtml', XHTML );
    $user_templates->set_var('site_url', $_CONF['site_url']);
    $user_templates->set_var('start_block_loginagain', COM_startBlock($LANG04[65]));
    $user_templates->set_var('lang_username', $LANG04[2]);
    $user_templates->set_var('lang_password', $LANG01[57]);
    $user_templates->set_var('lang_login', $LANG04[80]);
    $user_templates->set_var('end_block', COM_endBlock());
    $user_templates->parse('output', 'login');
    $retval .= $user_templates->finish($user_templates->get_var('output'));
    return $retval;
}

// Convert encoding
function MOBLOG_convertEncoding($str, $to_encoding)
{
    global $_MOBLOG_CONF;
    $list = 'ISO-2022-JP, UTF-8, eucjp-win, EUC-JP, sjis-win, SJIS, ISO-8859-1, ASCII';
    $from_encoding = mb_detect_encoding($str, $list);
    if (!$from_encoding) $from_encoding = $_MOBLOG_CONF['charset'];
    return mb_convert_encoding($str, $to_encoding, $from_encoding);
}

// リサイズ後の画像幅と画像高を得る
function MOBLOG_getResizedValue($src_w, $src_h, $max_w, $max_h)
{
    if ($src_w > $max_w || $src_h > $max_h) {
        $key_w = $max_w / $src_w;
        $key_h = $max_h / $src_h;
        $keys = ($key_w < $key_h) ? $key_w : $key_h;
        $src_w = $src_w * $keys;
        $src_h = $src_h * $keys;
    }
    return array($src_w, $src_h);
}

// サムネイル作成
function MOBLOG_createThumb($filename, $W, $H, $W2, $H2, $thumb_dir="./", $tmp_dir)
{
    global $_MOBLOG_CONF;

    $W  = (empty($W)  || $W  <= 0) ? $_MOBLOG_CONF['thmb_width']   : $W;
    $H  = (empty($H)  || $H  <= 0) ? $_MOBLOG_CONF['thmb_height']  : $H;
    $W2 = (empty($W2) || $W2 <= 0) ? $_MOBLOG_CONF['image_width']  : $W2;
    $H2 = (empty($H2) || $H2 <= 0) ? $_MOBLOG_CONF['image_height'] : $H2;

    $src_path = $tmp_dir . $filename;
    list($width, $height, $type, $attr) = getimagesize($src_path);
    switch ($type) {
        case IMAGETYPE_GIF:
             $im_in = imagecreatefromgif($src_path);
             $ext = '.gif';
             break;
        case IMAGETYPE_JPEG:
             $im_in = imagecreatefromjpeg($src_path);
             $ext = '.jpg';
             break;
        case IMAGETYPE_PNG:
             $im_in = imagecreatefrompng($src_path);
             $ext = '.png';
             break;
        default:
             $im_in = false;
             break;
    }
    if (!$im_in) return false;

    $filename_wo_ext = substr($filename, 0, strrpos($filename, "."));
    $thum_filename = '';

    list($out_w, $out_h) = MOBLOG_getResizedValue($width, $height, $W, $H);
    if ($width > $out_w || $height > $out_h) {
        $im_out = imagecreatetruecolor($out_w, $out_h);
        imagecopyresampled($im_out, $im_in, 0, 0, 0, 0, $out_w, $out_h, $width, $height);
        // サムネイル画像を保存
        $thum_filename = $filename_wo_ext . "-small.jpg";
        imagejpeg($im_out, $thumb_dir . $thum_filename);  // サムネイル作成
        imagedestroy($im_out);
    }

    // 元画像のサイズが設定値より大きい場合、元画像をリサイズする
    if ($width > $W2 || $height > $H2) {
        $backup = $filename_wo_ext . "-bak" . $ext;
        $rt = rename($tmp_dir . $filename, $tmp_dir . $backup); // 元画像をリネーム
        // if (!$rt) echo "rename err!";

        list($out_w, $out_h) = MOBLOG_getResizedValue($width, $height, $W2, $H2);
        $im_out2 = imagecreatetruecolor($out_w, $out_h);
        imagecopyresampled($im_out2, $im_in, 0, 0, 0, 0, $out_w, $out_h, $width, $height);
        // リサイズした画像を保存
        imagejpeg($im_out2, $tmp_dir . $filename_wo_ext . ".jpg");
        imagedestroy($im_out2);
        imagedestroy($im_in);

        $rt = unlink($tmp_dir . $backup); // 元画像を削除
        // if (!$rt) echo "delete err!";
        $filename = $filename_wo_ext . ".jpg";
    }
    return array($filename, $thum_filename);
}

// 画像部分のHTML
function MOBLOG_rendarImage($template, $A)
{
    global $_MOBLOG_CONF;
    $retval = "";
    if (file_exists($_MOBLOG_CONF['path_layout'] . $template)) {
        $T = new Template($_MOBLOG_CONF['path_layout']);
        $T->set_file('block', $template);
        $T->set_var('tmp_url',   $A['tmp_url']);
        $T->set_var('thumb_url', $A['thumb_url']);
        $T->set_var('width',     $A['width']);
        $T->set_var('height',    $A['height']);
        $T->set_var('filename',  $A['filename']);
        $T->parse('blockHTML', 'block');
        $retval .= $T->finish($T->get_var('blockHTML'));
    }
    return $retval;
}

// 記事のHTML
function MOBLOG_rendarMoblog($text, $images)
{
    global $_MOBLOG_CONF;
    $retval = "";
    if (file_exists($_MOBLOG_CONF['path_layout'] . 'moblog.thtml')) {
        $T = new Template($_MOBLOG_CONF['path_layout']);
        $T->set_file('moblog', 'moblog.thtml');
        $T->set_var('text',   $text);
        $T->set_var('images', $images);
        $T->parse('blockHTML', 'moblog');
        $retval .= $T->finish($T->get_var('blockHTML'));
    }
    return $retval;
}

// エラー処理
function error_handler($errno, $errmsg, $file, $line, $vars)
{
    global $_CONF, $logmode, $MESSAGE;

    $output = COM_siteHeader('menu');
    if ($errno == 2) {
        $output .= COM_showMessage (4, 'moblog');
    } else {
        $errmsg = MOBLOG_convertEncoding($errmsg, $to_encoding);
        $output .= COM_showMessageText($errmsg, $MESSAGE[40]);
    }
    $output .= COM_siteFooter();

    echo $output;
    exit;
}

// ログ出力処理
function MOBLOG_outLog($logentry, $logmode = 1)
{
    global $_CONF, $LANG01;

    if ($logmode == 0) return '';
    $retval = '';
    if (!empty($logentry)) {
        $logentry = str_replace(array('<?', '?>'), array('(@', '@)'), $logentry);
        $timestamp = strftime('%c');
        $logfile = $_CONF['path_log'] . 'moblog.log';
        $file = fopen($logfile, 'a');
        if (!$file) {
            $retval .= $LANG01[33] . ' ' . $logfile . ' (' . $timestamp . ')<br' . XHTML . '>' . LB;
        } else {
            fputs($file, "$timestamp - $logentry" . LB);
        }
        if ($logmode == 2) {
            $retval .= $logentry . '<br' . XHTML . '>' . LB;
        }
    }
    return $retval;
}

// $strを解析してオプションを得る
function MOBLOG_parseOption($str)
{
    $retval = array();
    $optary = explode('&', $str);
    foreach ($optary as $opt) {
        if (!empty($opt)) {
            list($k, $v) = explode('=', $opt);
            $retval[strtolower($k)] = $v;
        }
    }
    return $retval;
}


// MAIN
function MOBLOG_execProcess($display = '')
{
    global $_CONF, $_USER, $_TABLES, $LANG01,
           $_MOBLOG_CONF, $LANG_MOBLOG_1, $logmode;

    clearstatcache();

    $retval = COM_siteHeader('menu', $LANG_MOBLOG_1['plugin_name']);
    $retval .= COM_startBlock($LANG_MOBLOG_1['run_moblog']);
    if (!empty($display)) $retval .= $display;

    MOBLOG_outLog($LANG_MOBLOG_1['process_start'], 1);

    if (!is_dir($_MOBLOG_CONF['thumb_dir'])) {
        $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_thumb_dir_none'], 2);
        return MOBLOG_breakProcess($retval);
    }
    if (!is_dir($_MOBLOG_CONF['tmp_dir'])) {
        $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_tmp_dir_none'], 2);
        return MOBLOG_breakProcess($retval);
    }

    $server = array(
        'protocol' => 'pop3',
        'host' => $_MOBLOG_CONF['mailserver_host'],
        'port' => $_MOBLOG_CONF['mailserver_port'],
        'user' => $_MOBLOG_CONF['mailserver_user'],
        'pass' => $_MOBLOG_CONF['mailserver_pass'] );
    $receiver = QdmailReceiver::start('pop' , $server, 'utf-8');
    set_error_handler('error_handler');
    $result = $receiver->my_connect();
    restore_error_handler();
    if ($result) {
        $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_pop_open_success'], $logmode);
    } else {
        $receiver->done();
        $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_pop_open_failure'], $logmode);
        return MOBLOG_breakProcess($retval);
    }
    $buf = $receiver->my_sendCmd("USER {$_MOBLOG_CONF['mailserver_user']}");
    if (substr($buf, 0, 3) == '+OK') {
        $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_pop_id_success'], $logmode);
    } else {
        $receiver->done();
        $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_pop_id_failure'], $logmode);
        return MOBLOG_breakProcess($retval);
    }
    $buf = $receiver->my_sendCmd("PASS {$_MOBLOG_CONF['mailserver_pass']}");
    if (substr($buf, 0, 3) == '+OK') {
        $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_pop_pass_success'], $logmode);
    } else {
        $receiver->done();
        $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_pop_pass_failure'], $logmode);
        return MOBLOG_breakProcess($retval);
    }

    // メールの件数取得
    $num = $receiver->count();
    if ($num == "0") {
        $receiver->done();
        $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_pop_email_none'], $logmode);
        return MOBLOG_breakProcess($retval);
    }
    $retval .= MOBLOG_outLog(sprintf($LANG_MOBLOG_1['msg_pop_email_num'], $num), $logmode);

    for ($j=1; $j<=$num; $j++) {

        $receiver->pointer($j);
        $password = '';
        $write = true;

        // 送信者アドレス
        $this_uid = 1;
        $from = $receiver->header(array('from', 0, 'mail'), '');
        if (!empty($from)) {
            $this_uid = DB_getItem($_TABLES['moblog'], 'uid', "email = '$from'");
            if (!$this_uid) $this_uid = 1;
        }

        // ゲストユーザのメールの処理
        if ($this_uid == 1 && $_CONF['submitloginrequired'] == 1) {
            $logmsg = $from . " " . $LANG_MOBLOG_1['msg_disallow_guest'];
            $retval .= MOBLOG_outLog($logmsg, $logmode);
            continue;
        }

        $un = $LANG01[24]; // ゲストユーザ
        $this_password = '';
        if ($this_uid != 1) {
            $result = DB_query("SELECT * FROM {$_TABLES['moblog']} WHERE uid = '$this_uid'");
            $A = DB_fetchArray($result);
            $this_tid      = $A['default_tid'];
            $this_subject  = $A['default_subject'];
            $this_thumb_ok = $A['enable_thmb'];
            $this_password = $A['passwd'];
            $this_W  = $A['thmb_width'];
            $this_H  = $A['thmb_height'];
            $this_W2 = $A['image_width'];
            $this_H2 = $A['image_height'];
            $un = DB_getItem($_TABLES['users'], 'username', "uid = '$this_uid'");
        }
        if (empty($this_tid))      $this_tid      = $_MOBLOG_CONF['default_tid'];
        if (empty($this_subject))  $this_subject  = $_MOBLOG_CONF['default_subject'];
        if (empty($this_thumb_ok)) $this_thumb_ok = $_MOBLOG_CONF['enable_thmb'];
        if (empty($this_W))  $this_W  = $_MOBLOG_CONF['thmb_width'];
        if (empty($this_H))  $this_H  = $_MOBLOG_CONF['thmb_height'];
        if (empty($this_W2)) $this_W2 = $_MOBLOG_CONF['image_width'];
        if (empty($this_H2)) $this_H2 = $_MOBLOG_CONF['image_height'];
        $retval .= MOBLOG_outLog($LANG_MOBLOG_1['username'] . ": ". $un, $logmode);
        // $retval .= MOBLOG_outLog("From addr: " . $from, $logmode);
        $this_sid = COM_makesid();

        // 日付
        $pub_time = strtotime($receiver->header('date' , ''));
        if (empty($pub_time)) $pub_time = time();

        // 題名(サブジェクト)
        $subject = $receiver->header(array('subject','name'));

        // 題名からオプションを取り出す
        list($subject, $tmp) = explode($_MOBLOG_CONF['tid_separater'], $subject);
        if (!empty($tmp)) {
            $option = MOBLOG_parseOption($tmp);
            if (!empty($option['t'])) { // 話題ID
                if (DB_count($_TABLES['topics'], 'tid', $option['t']) > 0) {
                    $this_tid = $option['t'];
                }
            }
            if (!empty($option['i'])) { // 記事ID
                $sid_tmp = $option['i'];
                $pi = 1;
                while (DB_count($_TABLES['stories'], 'sid', $sid_tmp) > 0) {
                    $sid_tmp = $option['i'] . '_'. $pi;
                    $pi++;
                }
                while (DB_count($_TABLES['storysubmission'], 'sid', $sid_tmp) > 0) {
                    $sid_tmp = $option['i'] . '_'. $pi;
                    $pi++;
                }
                $this_sid = $sid_tmp;
            }
            if (!empty($option['p'])) { // パスワード
                $password =  $option['p'];
            }
        }
        if (trim(htmlspecialchars($subject)) != "") {
        }
            $this_subject = $subject;

        // Moblog用パスワード認証
        if ($this_uid != 1 && !empty($this_password)) {
            if ($this_password != $password) {
                $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_mismatch_pass'], 2);
                continue;
            }
        }

        // 本文
        $text = $receiver->bodyAutoSelect();
        // サニタイジング＆改行を<br>に置換
        $text = str_replace(">", "&gt;", $text);
        $text = str_replace("<", "&lt;", $text);
        $text = str_replace("\r\n", "\r", $text);
        $text = str_replace("\r", "\n", $text);
        $text = preg_replace("/\n{2,}/", "\n\n", $text);
        $text = str_replace("\n", "<br" . XHTML . ">", $text);

        // 添付ファイル
        $attach = $receiver->attach();
        $cnt = 0; // 添付ファイル数のカウンタ
        foreach ($attach as $att) {

            list($main, $sub) = explode("/", $att['mimetype']);
            if (strtolower($main) == "image") {

                $filename = $att['filename']; // 日本語デコード済みファイル名
                // 問題文字を除く
                $filename = str_replace("&", "", $filename);
                $filename = str_replace("'", "", $filename);
                $filename = str_replace("/", "", $filename);
                list($filename_ds, $Dummy) = explode(".", $filename); // 本文表示用
                if (empty($filename)) {
                    $filename = date(YmdHis) . ".$sub";
                } else {
                    $filename = date(YmdHis) . "_" . $filename; // ファイル名に時間を付加する
                }

                $tmp = $att['value']; // 画像
                if (strlen($tmp) < $_MOBLOG_CONF['image_maxbyte']
                        && !preg_match('/' . $_MOBLOG_CONF['viri'] . '/i', $filename)) {
                    $fp = fopen($_MOBLOG_CONF['tmp_dir'] . $filename, "w");
                    fputs($fp, $tmp);
                    fclose($fp);
                    $link = rawurlencode($filename);
                    $size = getimagesize($_MOBLOG_CONF['tmp_dir'] . $filename);
                    $result = '';
                    if ($this_thumb_ok && function_exists('imagecreate')) {
                        if (preg_match('/' . $_MOBLOG_CONF['thumb_ext'] . '/i', $filename)) {
                            if ($size[0] > $this_W || $size[1] > $this_H) {
                                $result = MOBLOG_createThumb($filename,
                                             $this_W, $this_H, $this_W2, $this_H2,
                                             $_MOBLOG_CONF['thumb_dir'], $_MOBLOG_CONF['tmp_dir']);
                            }
                        }
                    }
                    // 添付ファイルの情報を配列に記憶する
                    $cnt++;
                    $fname[$cnt]       = (is_array($result)) ? $result[0] : $filename;
                    $thumb_fname[$cnt] = (is_array($result)) ? $result[1] : '';
                    $fname_ds[$cnt] = $filename_ds;
                } else {
                    $write = false;
                }
            }
        }

        if ($write == false) {
            $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_skip_by_limits'], $logmode);
            continue;
        }

        $images = '';
        for ($cnti=1; $cnti<=$cnt; $cnti++) {
            $A = array();
            $A['filename'] = $fname_ds[$cnti];
            if (!empty($thumb_fname[$cnti])) {
                $size = getimagesize($_MOBLOG_CONF['tmp_dir'] . $thumb_fname[$cnti]);
                $template = 'photo.thtml';
                $A['tmp_url']   = $_MOBLOG_CONF['tmp_url'] . $fname[$cnti];
                $A['thumb_url'] = $_MOBLOG_CONF['thumb_url'] . $thumb_fname[$cnti];
                $A['width']  = $size[0];
                $A['height'] = $size[1];
            } else { // サムネイルがない場合
                $size = getimagesize($_MOBLOG_CONF['tmp_dir'] . $fname[$cnti]);
                $template = 'photo_no_thumb.thtml';
                $A['tmp_url']   = $_MOBLOG_CONF['tmp_url'] . $fname[$cnti];
                $A['thumb_url'] = '';
                list($A['width'], $A['height']) = MOBLOG_getResizedValue($size[0], $size[1], $this_W, $this_H);
            }
            $images .= MOBLOG_rendarImage($template, $A);
        }
        $this_text = MOBLOG_rendarMoblog($text, $images);

        $args = array(
            'uid'       => $this_uid,
            'tid'       => $this_tid,
            'sid'       => $this_sid,
            'title'     => $this_subject,
            'introtext' => $this_text,
            'bodytext'  => '',
            'postmode'  => 'html');

        if (!SEC_hasRights_uid('story.edit', 'AND', $this_uid)) {
        // ↑submit.phpの433行目の判定と同じ。
        // 'story.edit'の権限を持つと記事投稿の管理者承認はスキップできるらしい。
            $args = array_merge($args,
                array('owner_id'  => $this_uid,
                      'group_id'  => 2 )); // grp_id 1 = Root, 2 = All Users // 不要？
            $post_directly = ($_CONF['storysubmission'] != 1);
            $result = MOBLOG_savestory($args, $post_directly);
            if ($result == STORY_NO_ACCESS_TOPIC) {
                $retval .= MOBLOG_outLog(sprintf($LANG_MOBLOG_1['msg_no_access_topic'], $this_tid), 2);
            } else if ($result == STORY_SAVED || $result == STORY_SAVED_SUBMISSION) {
                if ($result == STORY_SAVED) {
                    $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_post_success'], 2);
                } else {
                    $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_submission_success'], 2);
                }
                $receiver->delete($j); // メッセージ削除
            }
        } else {
            $args = array_merge($args,
                array('publish_year'   => date('Y', $pub_time),
                      'publish_month'  => date('m', $pub_time),
                      'publish_day'    => date('d', $pub_time),
                      'publish_hour'   => date('H', $pub_time),
                      'publish_minute' => date('i', $pub_time),
                      'publish_second' => date('s', $pub_time) ));
            $result = MOBLOG_submitStory($args);
            if ($result == PLG_RET_OK) {
                $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_post_success'], 2);
                $receiver->delete($j); // メッセージ削除
            } else if ($result == PLG_RET_ERROR) {
                $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_post_error'], 2);
            } else {
                $retval .= MOBLOG_outLog($LANG_MOBLOG_1['msg_permission_denied'], 2);
            }
        }
    }
    $receiver->done();
    MOBLOG_outLog($LANG_MOBLOG_1['process_end'], 1);
    $retval .= COM_endBlock();
    $retval .= COM_siteFooter(false);
    return $retval;
}

function MOBLOG_breakProcess($retval)
{
    global $LANG_MOBLOG_1;

    MOBLOG_outLog($LANG_MOBLOG_1['process_break'], 1);
    $retval .= COM_endBlock();
    $retval .= COM_siteFooter(true);
    return $retval;
}

?>