<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Moblog Plugin                                                             |
// +---------------------------------------------------------------------------+
// | moblog/userconf.php                                                       |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009 by the following authors:                              |
// |                                                                           |
// | Authors: Yoshinori Tahara - taharaxp AT gmail DOT com                     |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

/**
* @package Moblog
*/

require_once '../lib-common.php';

if (!defined ('UC_SELECTED')) define('UC_SELECTED', (XHTML == '') ? 'selected' : 'selected="selected"');

// take user back to the homepage if the plugin is not active
if (! in_array('moblog', $_PLUGINS)) {
    echo COM_refresh($_CONF['site_url'] . '/index.php');
    exit;
}

if (empty($_USER['username'])) { // ゲストユーザーを制限する（暫定）
    $display .= COM_siteHeader ('menu', $LANG_LINKS[114]);
    $display .= COM_startBlock ($LANG_LOGIN[1], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
    $login = new Template ($_CONF['path_layout'] . 'submit');
    $login->set_file (array ('login' => 'submitloginrequired.thtml'));
    $login->set_var ( 'xhtml', XHTML );
    $login->set_var ('login_message', $LANG_LOGIN[2]);
    $login->set_var ('site_url', $_CONF['site_url']);
    $login->set_var ('lang_login', $LANG_LOGIN[3]);
    $login->set_var ('lang_newuser', $LANG_LOGIN[4]);
    $login->parse ('output', 'login');
    $display .= $login->finish ($login->get_var ('output'));
    $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $display .= COM_siteFooter ();
    COM_output($display);
    exit;
}

$MBDAT = array();

function MOBLOG_setMBDAT()
{
    global $MBDAT;

    $email = trim($_POST['email']);
    $MBDAT = array(
        'email'           => empty($email) ? '' : strip_tags($email),
        'default_tid'     => COM_applyFilter($_POST['default_tid']),
        'default_subject' => COM_applyFilter($_POST['default_subject']),
        'password'        => COM_applyFilter($_POST['password']),
        'enable_thmb'     => ($_POST['enable_thmb'] == '0') ? 1 : 0,
        'thmb_width'      => COM_applyFilter($_POST['thmb_width'], true),
        'thmb_height'     => COM_applyFilter($_POST['thmb_height'], true),
        'image_width'     => COM_applyFilter($_POST['image_width'], true),
        'image_height'    => COM_applyFilter($_POST['image_height'], true),
    );
}

function MOBLOG_validateMBDAT($mode)
{
    global $_TABLES, $LANG_MOBLOG_1, $MBDAT;

    $retval = '';

    return $retval;
}

function MOBLOG_editConfigulation ($dat = array())
{
    global $_CONF, $_TABLES, $_USER, $_MOBLOG_CONF, $LANG_MOBLOG_1;
    
    $retval = COM_startBlock($LANG_MOBLOG_1['user_setting']);
    
    $uid = DB_getItem($_TABLES['users'], 'uid', "username = '{$_USER['username']}'");
    if (!empty($dat)) {
        $A['uid']             = $uid;
        $A['email']           = $dat['email'];
        $A['default_tid']     = $dat['default_tid'];
        $A['default_subject'] = $dat['default_subject'];
        $A['enable_thmb']     = $dat['enable_thmb'];
        $A['thmb_width']      = $dat['thmb_width'];
        $A['thmb_height']     = $dat['thmb_height'];
        $A['image_width']     = $dat['image_width'];
        $A['image_height']    = $dat['image_height'];
        $A['password']        = $dat['password'];
    } else {
        $result = DB_query("SELECT * FROM {$_TABLES['moblog']} WHERE uid ='$uid'");
        $A = DB_fetchArray($result);
    }
    $T = new Template($_MOBLOG_CONF['path_layout']);
    $T->set_file('userconf', 'userconf.thtml');
    $T->set_var('xhtml',          XHTML);
    $T->set_var('site_url',       $_CONF['site_url']);
    $T->set_var('site_admin_url', $_CONF['site_admin_url']);
    $T->set_var('icon_url',       plugin_geticon_moblog());
    $T->set_var('layout_url',     $_CONF['layout_url']);

    foreach ($LANG_MOBLOG_1 as $key => $val) {
        $T->set_var('lang_'.$key, $val);
    }
    $T->set_var('val_username',        $_USER['username']);
    $T->set_var('val_email',           $A['email']);
    $T->set_var('val_default_tid',     $A['default_tid']);
    $T->set_var('val_default_subject', $A['default_subject']);
    $T->set_var('val_enable_thmb_0',   ($A['enable_thmb'] == 1)  ? UC_SELECTED : '');
    $T->set_var('val_enable_thmb_1',   ($A['enable_thmb'] != 1)  ? UC_SELECTED : '');
    $T->set_var('val_password',        $A['passwd']);
    $T->set_var('val_thmb_width',      $A['thmb_width']);
    $T->set_var('val_thmb_height',     $A['thmb_height']);
    $T->set_var('val_image_width',     $A['image_width']);
    $T->set_var('val_image_height',    $A['image_height']);
    if (!defined(CSRF_TOKEN)) define('CSRF_TOKEN', 'token');
    $T->set_var('gltoken_name', CSRF_TOKEN);
    $T->set_var('gltoken', SEC_createToken());
    $T->parse('output', 'userconf');
    $retval .= $T->finish($T->get_var('output'));

    $retval .= COM_endBlock();

    return $retval;
}

function MOBLOG_saveConfigulation($mode)
{
    global $_TABLES, $_USER, $LANG_MOBLOG_1, $MBDAT;

    $retval = '';
    
    $MBDAT['uid'] = DB_getItem($_TABLES['users'], 'uid', "username = '{$_USER['username']}'");
    $MBDAT['email']           = addslashes(COM_stripslashes(strip_tags($MBDAT['email'])));
    $MBDAT['default_tid']     = addslashes(COM_stripslashes(strip_tags($MBDAT['default_tid'])));
    $MBDAT['default_subject'] = addslashes(COM_stripslashes(strip_tags($MBDAT['default_subject'])));
    $MBDAT['password']        = addslashes(COM_stripslashes(strip_tags($MBDAT['password'])));

    DB_save($_TABLES['moblog'],
            'uid, email, default_tid, default_subject, enable_thmb, thmb_width, thmb_height, image_width, image_height, passwd',
            "'" . $MBDAT['uid']             . "','" . $MBDAT['email']       . "','" . $MBDAT['default_tid']  . "','"
                . $MBDAT['default_subject'] . "','" . $MBDAT['enable_thmb'] . "','" . $MBDAT['thmb_width']   . "','"
                . $MBDAT['thmb_height']     . "','" . $MBDAT['image_width'] . "','" . $MBDAT['image_height'] . "','"
                . $MBDAT['password']  . "'" );

    return $retval;
}

$display = '';

// MAIN
$mode = (!empty($_REQUEST['mode'])) ? $_REQUEST['mode'] : '';
$mode = (($mode == $LANG_ADMIN['save'])   && !empty($LANG_ADMIN['save']))   ? 'save'   : $mode;
$mode = (($mode == $LANG_ADMIN['cancel']) && !empty($LANG_ADMIN['cancel'])) ? 'cancel' : $mode;

if (($mode == 'save') && SEC_checkToken()) {
    MOBLOG_setMBDAT();
    $msg = MOBLOG_validateMBDAT($mode);
    if (empty($msg)) {
        $msg = MOBLOG_saveConfigulation($mode);
        echo COM_refresh($_CONF['site_url'] . '/index.php?msg=2&plugin=moblog');
        exit;
    } else {
        $display .= COM_siteHeader('menu', $LANG_MOBLOG_1['user_setting']);
        $display .= COM_startBlock($LANG_MOBLOG_1['error_field'], '', COM_getBlockTemplate('_msg_block', 'header'));
        $display .= $msg;
        $display .= COM_endBlock(COM_getBlockTemplate('_msg_block', 'footer'));
        $display .= MOBLOG_editConfigulation($MBDAT);
        $display .= COM_siteFooter();
    }
} else if ($mode == 'cancel') {
    echo COM_refresh($_CONF['site_url'] . '/index.php?msg=3&plugin=moblog');
    exit;
} else {
    $display .= COM_siteHeader('menu', $LANG_MOBLOG_1['user_setting']);
    $display .= MOBLOG_editConfigulation();
    $display .= COM_siteFooter();
}

COM_output($display);
?>